]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Die IDE/SCSI/SATA/USB-Erkennung erstellt nun schoene Ramdisks :D
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 ipfiremake fcpci SMP=1
337 # ipfiremake promise-sata-300-tx SMP=1
338 ipfiremake zaptel SMP=1
339 ipfiremake fuse SMP=1
340 ipfiremake linux
341 ipfiremake ipp2p
342 ipfiremake fcdsl
343 ipfiremake fcdsl2
344 ipfiremake fcdslsl
345 ipfiremake fcdslusb
346 ipfiremake fcdslslusb
347 ipfiremake fcpci
348 # ipfiremake promise-sata-300-tx
349 ipfiremake zaptel
350 ipfiremake fuse
351 ipfiremake pkg-config
352 ipfiremake cpio
353 ipfiremake klibc
354 ipfiremake mkinitcpio
355 ipfiremake udev KLIBC=1
356 ipfiremake expat
357 ipfiremake gdbm
358 ipfiremake gmp
359 ipfiremake pam
360 ipfiremake openssl
361 ipfiremake python
362 ipfiremake libnet
363 ipfiremake libjpeg
364 ipfiremake libpng
365 ipfiremake libtiff
366 ipfiremake lcms
367 ipfiremake libmng
368 ipfiremake freetype
369 ipfiremake libart
370 ipfiremake gd
371 ipfiremake popt
372 ipfiremake pcre
373 ipfiremake slang
374 ipfiremake newt
375 ipfiremake libcap
376 ipfiremake pciutils
377 ipfiremake libxml2
378 ipfiremake BerkeleyDB
379 ipfiremake mysql
380 ipfiremake cyrus-sasl
381 ipfiremake openldap
382 ipfiremake apache2
383 ipfiremake php
384 ipfiremake apache2 PASS=C
385 ipfiremake arping
386 ipfiremake beep
387 ipfiremake bind
388 ipfiremake capi4k-utils
389 ipfiremake cdrtools
390 ipfiremake dnsmasq
391 ipfiremake dosfstools
392 ipfiremake reiserfsprogs
393 ipfiremake squashfstools
394 ipfiremake sysfsutils
395 ipfiremake ntfs-3g
396 ipfiremake ethtool
397 ipfiremake ez-ipupdate
398 ipfiremake fcron
399 ipfiremake GD
400 ipfiremake GD-Graph
401 ipfiremake GD-TextUtil
402 ipfiremake gnupg
403 ipfiremake hdparm
404 ipfiremake ibod
405 ipfiremake initscripts
406 ipfiremake whatmask
407 ipfiremake iptables
408 ipfiremake libupnp
409 ipfiremake ipp2p IPT=1
410 ipfiremake moblock
411 ipfiremake linux-igd
412 ipfiremake ipac-ng
413 ipfiremake ipaddr
414 ipfiremake iptstate
415 ipfiremake iputils
416 ipfiremake l7-protocols
417 ipfiremake isapnptools
418 # ipfiremake isdn4k-utils # What about mISDN???
419 ipfiremake hwdata
420 ipfiremake kudzu
421 ipfiremake logrotate
422 ipfiremake logwatch
423 ipfiremake misc-progs
424 ipfiremake mtools
425 ipfiremake nano
426 ipfiremake nash
427 ipfiremake nasm
428 ipfiremake URI
429 ipfiremake HTML-Tagset
430 ipfiremake HTML-Parser
431 ipfiremake Compress-Zlib
432 ipfiremake Digest
433 ipfiremake Digest-SHA1
434 ipfiremake Digest-HMAC
435 ipfiremake libwww-perl
436 ipfiremake Net-DNS
437 ipfiremake Net-IPv4Addr
438 ipfiremake Net_SSLeay
439 ipfiremake IO-Stringy
440 ipfiremake Unix-Syslog
441 ipfiremake Mail-Tools
442 ipfiremake MIME-Tools
443 ipfiremake Net-Server
444 ipfiremake Convert-TNEF
445 ipfiremake Convert-UUlib
446 ipfiremake Archive-Tar
447 ipfiremake Archive-Zip
448 ipfiremake Text-Tabs+Wrap
449 ipfiremake Locale-Country
450 ipfiremake XML-Parser
451 ipfiremake glib
452 ipfiremake GeoIP
453 ipfiremake fwhits
454 ipfiremake noip_updater
455 ipfiremake ntp
456 ipfiremake openssh
457 ipfiremake openswan
458 ipfiremake pptpclient
459 ipfiremake rrdtool
460 ipfiremake setserial
461 ipfiremake setup
462 ipfiremake snort
463 ipfiremake snortsnarf
464 ipfiremake oinkmaster
465 ipfiremake squid
466 ipfiremake squid-graph
467 ipfiremake squidguard
468 ipfiremake calamaris
469 ipfiremake tcpdump
470 ipfiremake traceroute
471 ipfiremake vlan
472 ipfiremake wireless
473 ipfiremake libsafe
474 ipfiremake 3c5x9setup
475 ipfiremake pakfire
476 ipfiremake java
477 ipfiremake bootsplash
478 ipfiremake spandsp
479 ipfiremake lzo
480 ipfiremake openvpn
481 ipfiremake pammysql
482 ipfiremake ghostscript
483 ipfiremake cups
484 ipfiremake samba
485 ipfiremake sudo
486 ipfiremake mc
487 ipfiremake wget
488 ipfiremake bridge-utils
489 ipfiremake screen
490 ipfiremake hddtemp
491 ipfiremake smartmontools
492 ipfiremake htop
493 ipfiremake postfix
494 ipfiremake fetchmail
495 ipfiremake cyrusimap
496 ipfiremake webcyradm
497 ipfiremake mailx
498 ipfiremake clamav
499 ipfiremake spamassassin
500 ipfiremake amavisd
501 ipfiremake stund
502 ipfiremake libpri
503 # ipfiremake bristuff
504 ipfiremake asterisk
505 ipfiremake mpg123
506 ipfiremake libmad
507 ipfiremake libogg
508 ipfiremake libvorbis
509 ipfiremake lame
510 ipfiremake sox
511 ipfiremake gnump3d
512 ipfiremake applejuice
513 ipfiremake ocaml
514 ipfiremake mldonkey
515 ipfiremake rsync
516 ipfiremake tcpwrapper
517 ipfiremake portmap
518 ipfiremake nfs
519 ipfiremake nmap
520 ipfiremake mbmon
521 ipfiremake iftop
522 ipfiremake ncftp
523 ipfiremake cftp
524 ipfiremake etherwake
525 ipfiremake ethereal
526 ipfiremake tftp-hpa
527 ipfiremake bwm-ng
528 ipfiremake tripwire
529 ipfiremake sysstat
530 }
531
532 buildinstaller() {
533 # Run installer scripts one by one
534 LOGFILE="$BASEDIR/log/_build.installer.log"
535 export LOGFILE
536 ipfiremake syslinux
537 ipfiremake as86
538 ipfiremake mbr
539 ipfiremake memtest
540 installmake linux-libc-header
541 installmake binutils
542 ipfiremake uClibc PASS=1
543 ipfiremake gcc INST=1
544 installmake uClibc PASS=2
545 installmake gcc INST=2
546 installmake uClibc PASS=3
547 installmake busybox
548 installmake udev
549 installmake slang
550 installmake newt
551 installmake gettext
552 installmake kbd
553 installmake popt
554 installmake sysvinit
555 installmake misc-progs
556 installmake e2fsprogs
557 installmake libaal
558 installmake reiser4progs
559 installmake reiserfsprogs
560 installmake sysfsutils
561 installmake util-linux
562 installmake pciutils
563 installmake zlib
564 installmake mtd
565 installmake wget
566 installmake hwdata
567 installmake kudzu
568 installmake installer
569 installmake initrd
570 }
571
572 buildpackages() {
573 LOGFILE="$BASEDIR/log/_build.packages.log"
574 export LOGFILE
575 echo "... see detailed log in _build.*.log files" >> $LOGFILE
576
577 installmake strip
578
579 # Generating list of packages used
580 echo -n "Generating packages list from logs" | tee -a $LOGFILE
581 rm -f $BASEDIR/doc/packages-list
582 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
583 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
584 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
585 fi
586 done
587 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
588 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
589 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
590 rm -f $BASEDIR/doc/packages-list
591 # packages-list.txt is ready to be displayed for wiki page
592 beautify message DONE
593
594 # Create images for install
595 if [ "$DEVEL" == "1" ]; then
596 ipfiremake cdrom ED=devel
597 fi
598 ipfiremake cdrom ED=full
599
600 # Check if there is a loop device for building in virtual environments
601 if [ -e /dev/loop0 ]; then
602 ipfiremake usb-stick
603 fi
604 ipfiremake pxe
605 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
606
607 ipfirepackages
608
609 # Cleanup
610 stdumount
611 rm -rf $BASEDIR/build/tmp/*
612
613 # Generating total list of files
614 echo -n "Generating files list from logs" | tee -a $LOGFILE
615 rm -f $BASEDIR/log/FILES
616 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
617 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
618 echo "##" >>$BASEDIR/log/FILES
619 echo "## `basename $i`" >>$BASEDIR/log/FILES
620 echo "##" >>$BASEDIR/log/FILES
621 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
622 fi
623 done
624 beautify message DONE
625
626 cd $PWD
627 }
628
629 ipfirepackages() {
630 # ipfiredist amavisd
631 # ipfiredist applejuice
632 # ipfiredist asterisk
633 ipfiredist clamav
634 # ipfiredist cups
635 # ipfiredist cyrusimap
636 # ipfiredist fetchmail
637 # ipfiredist gnump3d
638 # ipfiredist java
639 # ipfiredist mailx
640 # ipfiredist mldonkey
641 # ipfiredist nfs
642 # ipfiredist postfix
643 ipfiredist samba
644 # ipfiredist sox
645 # ipfiredist spamassassin
646 ipfiredist tripwire
647 # ipfiredist webcyradm
648 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
649 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
650 rm -rf $BASEDIR/build/install/packages/*
651 }
652
653 # See what we're supposed to do
654 case "$1" in
655 build)
656 clear
657 BUILDMACHINE=`uname -m`
658 DEVEL=0
659 if [ "$2" == "--devel" ]; then
660 DEVEL=1
661 fi
662 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
663 #only restore on a clean disk
664 if [ ! -f log/cleanup-toolchain-2-tools ]; then
665 if [ ! -n "$PACKAGE" ]; then
666 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
667 prepareenv
668 buildtoolchain
669 else
670 PACKAGENAME=${PACKAGE%.tar.gz}
671 beautify build_stage "Packaged toolchain compilation"
672 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
673 tar zxf $PACKAGE
674 prepareenv
675 else
676 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
677 fi
678 fi
679 else
680 echo -n "Using installed toolchain" | tee -a $LOGFILE
681 beautify message SKIP
682 prepareenv
683 fi
684
685 beautify build_start
686 beautify build_stage "Building LFS"
687 buildbase
688
689 beautify build_stage "Building IPFire"
690 buildipfire
691
692 # Setzen des IPFire Builds
693 if [ "$FIREBUILD" ]; then
694 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
695 else
696 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
697 fi
698
699 beautify build_stage "Building installer"
700 buildinstaller
701
702 beautify build_stage "Building packages"
703 buildpackages
704 beautify build_end
705 ;;
706 shell)
707 # enter a shell inside LFS chroot
708 # may be used to changed kernel settings
709 prepareenv
710 entershell
711 ;;
712 changelog)
713 echo -n "Loading new Changelog from SVN: "
714 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
715 beautify message DONE
716 ;;
717 clean)
718 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
719 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
720 $LOSETUP -d $i 2>/dev/null
721 done
722 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
723 umount $i
724 done
725 stdumount
726 for i in `seq 0 7`; do
727 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
728 umount /dev/loop${i} 2>/dev/null;
729 losetup -d /dev/loop${i} 2>/dev/null;
730 fi;
731 done
732 rm -rf $BASEDIR/build
733 rm -rf $BASEDIR/cdrom
734 rm -rf $BASEDIR/packages
735 rm -rf $BASEDIR/log
736 if [ -h /tools ]; then
737 rm -f /tools
738 fi
739 beautify message DONE
740 ;;
741 downloadsrc)
742 if [ ! -d $BASEDIR/cache ]; then
743 mkdir $BASEDIR/cache
744 fi
745 mkdir -p $BASEDIR/log
746 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
747 FINISHED=0
748 cd $BASEDIR/lfs
749 for c in `seq $MAX_RETRIES`; do
750 if (( FINISHED==1 )); then
751 break
752 fi
753 FINISHED=1
754 cd $BASEDIR/lfs
755 for i in *; do
756 if [ -f "$i" -a "$i" != "Config" ]; then
757 echo -ne "Loading $i"
758 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
759 if [ $? -ne 0 ]; then
760 beautify message FAIL
761 FINISHED=0
762 else
763 if [ $c -eq 1 ]; then
764 beautify message DONE
765 fi
766 fi
767 fi
768 done
769 done
770 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
771 ERROR=0
772 for i in *; do
773 if [ -f "$i" -a "$i" != "Config" ]; then
774 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
775 if [ $? -ne 0 ]; then
776 echo -ne "MD5 difference in lfs/$i"
777 beautify message FAIL
778 ERROR=1
779 fi
780 fi
781 done
782 if [ $ERROR -eq 0 ]; then
783 echo -ne "${BOLD}all files md5sum match${NORMAL}"
784 beautify message DONE
785 else
786 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
787 beautify message FAIL
788 fi
789 cd - >/dev/null 2>&1
790 ;;
791 toolchain)
792 clear
793 prepareenv
794 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
795 buildtoolchain
796 BUILDMACHINE=`uname -m`
797 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
798 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
799 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
800 build/{bin,etc,usr/bin,usr/local} \
801 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
802 log >> $LOGFILE
803 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
804 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
805 stdumount
806 ;;
807 gettoolchain)
808 BUILDMACHINE=`uname -m`
809 # arbitrary name to be updated in case of new toolchain package upload
810 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
811 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
812 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
813 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
814 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
815 cd $BASEDIR/cache/toolchains
816 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
817 if [ $? -ne 0 ]; then
818 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
819 else
820 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
821 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
822 else
823 exiterror "$PACKAGE.md5 did not match, check downloaded package"
824 fi
825 fi
826 else
827 echo "Toolchain is already downloaded. Exiting..."
828 fi
829 ;;
830 othersrc)
831 prepareenv
832 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
833 chroot $LFS /tools/bin/env -i HOME=/root \
834 TERM=$TERM PS1='\u:\w\$ ' \
835 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
836 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
837 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
838 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
839 if [ $? -eq "0" ]; then
840 beautify message DONE
841 else
842 beautify message FAIL
843 fi
844 stdumount
845 ;;
846 svn)
847 case "$2" in
848 update|up)
849 # clear
850 echo -ne "Loading the latest source files...\n"
851 if [ $3 ]; then
852 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
853 else
854 svn update | tee -a $PWD/log/_build.svn.update.log
855 fi
856 if [ $? -eq "0" ]; then
857 beautify message DONE
858 else
859 beautify message FAIL
860 exit 1
861 fi
862 echo -ne "Writing the svn-info to a file"
863 svn info > $PWD/svn_status
864 if [ $? -eq "0" ]; then
865 beautify message DONE
866 else
867 beautify message FAIL
868 exit 1
869 fi
870 chmod 755 $0
871 exit 0
872 ;;
873 commit|ci)
874 clear
875 if [ -f /usr/bin/mcedit ]; then
876 export EDITOR=/usr/bin/mcedit
877 fi
878 if [ -f /usr/bin/nano ]; then
879 export EDITOR=/usr/bin/nano
880 fi
881 echo -ne "Selecting editor $EDITOR..."
882 beautify message DONE
883 if [ -e /sbin/yast ]; then
884 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
885 $0 changelog
886 fi
887 fi
888 update_langs
889 svn commit
890 $0 svn up
891 if [ -n "$FTP_CACHE_URL" ]; then
892 $0 uploadsrc
893 fi
894 ;;
895 dist)
896 if [ $3 ]; then
897 SVN_REVISION=$3
898 fi
899 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
900 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
901 exit 0
902 fi
903 echo -en "REV $SVN_REVISION: Downloading..."
904 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
905 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
906 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
907 evaluate 1
908
909 echo -en "REV $SVN_REVISION: Compressing files..."
910 if [ -e ipfire-source/trunk/make.sh ]; then
911 chmod 755 ipfire-source/trunk/make.sh
912 fi
913 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
914 evaluate 1
915 echo -en "REV $SVN_REVISION: Cleaning up..."
916 rm ipfire-source/ -r
917 evaluate 1
918 ;;
919 diff|di)
920 update_langs
921 echo -ne "Make a local diff to last svn revision"
922 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
923 evaluate 1
924 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
925 svn status
926 ;;
927 esac
928 ;;
929 uploadsrc)
930 PWD=`pwd`
931 cd $BASEDIR/cache/
932 echo -e "Uploading cache to ftp server:"
933 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
934 for i in *; do
935 if [ "$i" == "toolchains" ]; then continue; fi
936 grep -q $i /tmp/ftplist
937 if [ "$?" -ne "0" ]; then
938 echo -ne "$i"
939 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
940 if [ "$?" -ne "0" ]; then
941 beautify message FAIL
942 fi
943 fi
944 done
945 rm -f /tmp/ftplist
946 cd $PWD
947 exit 0
948 ;;
949 upload)
950 case "$2" in
951 iso)
952 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
953 cat <<EOF > .ftp-commands
954 mkdir -p $FTP_ISO_PATH/$SVN_REVISION
955 ls -lah
956 quit
957 EOF
958 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
959 rm -f .ftp-commands
960 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
961 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
962 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
963 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
964 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
965 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
966 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
967 fi
968 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
969 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
970 if [ "$?" -eq "0" ]; then
971 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
972 else
973 echo -e "There was an error while uploading the iso to the ftp server."
974 exit 1
975 fi
976 if [ "$3" = "--with-sources-cd" ]; then
977 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
978 fi
979 ;;
980 paks)
981 cat <<EOF > .ftp-commands
982 mkdir -p $FTP_ISO_PATH/$SVN_REVISION/paks
983 ls -lah
984 quit
985 EOF
986 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
987 rm -f .ftp-commands
988 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
989 if [ "$?" -eq "0" ]; then
990 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
991 else
992 echo -e "There was an error while uploading the packages to the ftp server."
993 exit 1
994 fi
995 ;;
996 esac
997 ;;
998 batch)
999 if [ "$2" = "--background" ]; then
1000 batch_script
1001 exit $?
1002 fi
1003 if [ `screen -ls | grep -q ipfire` ]; then
1004 echo "Build is already running, sorry!"
1005 exit 1
1006 else
1007 if [ "$2" = "--rebuild" ]; then
1008 export IPFIRE_REBUILD=1
1009 echo "REBUILD!"
1010 else
1011 export IPFIRE_REBUILD=0
1012 fi
1013 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1014 screen -dmS ipfire $0 batch --background
1015 evaluate 1
1016 exit 0
1017 fi
1018 ;;
1019 watch)
1020 watch_screen
1021 ;;
1022 pxe)
1023 case "$2" in
1024 start)
1025 start_tftpd
1026 ;;
1027 stop)
1028 stop_tftpd
1029 ;;
1030 reload|restart)
1031 reload_tftpd
1032 ;;
1033 esac
1034 exit 0
1035 ;;
1036 lang)
1037 update_langs
1038 ;;
1039 packages)
1040 case "$2" in
1041 sign)
1042 sign_packages
1043 ;;
1044 esac
1045 ;;
1046 "")
1047 clear
1048 svn info
1049 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1050 do
1051 case $name in
1052 "IPFIRE: Downloadsrc")
1053 $0 downloadsrc
1054 ;;
1055 "IPFIRE: Build (silent)")
1056 $0 build-silent
1057 ;;
1058 "IPFIRE: Watch Build")
1059 $0 watch
1060 ;;
1061 "IPFIRE: Batch")
1062 $0 batch
1063 ;;
1064 "IPFIRE: Clean")
1065 $0 clean
1066 ;;
1067 "SVN: Update")
1068 $0 svn update
1069 ;;
1070 "Help")
1071 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1072 cat doc/make.sh-usage
1073 ;;
1074 "LOG: Tail")
1075 tail -f log/_*
1076 ;;
1077 "Exit")
1078 break
1079 ;;
1080 esac
1081 done
1082 ;;
1083 config)
1084 make_config
1085 ;;
1086 *)
1087 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1088 cat doc/make.sh-usage
1089 ;;
1090 esac